﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System.Collections.Generic;
using System.Linq;

namespace QPR.QPRSuite.NCalc {

    public class arrayexcept : CustomFunctionBase {

        private object[] inputArray1;
        private object[] inputArray2;

        public arrayexcept(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "object[]", "object[]" }) {
            this.inputArray1 = (object[])this.parameters[0];
            this.inputArray2 = (object[])this.parameters[1];
        }

        public override object evaluate() {
            if (this.inputArray1 == null) return this.inputArray2;
            if (this.inputArray2 == null) return this.inputArray1;
            List<object> outputList = new List<object>();
            for (int i = 0; i < inputArray1.Length; i++) {
                if (!inputArray2.Contains(inputArray1[i])) outputList.Add(inputArray1[i]);
            }
            return outputList.ToArray();
        }

    }
}