﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {
    public class converttodouble : CustomFunctionBase {

        public converttodouble(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object", "double" }) {
        }

        public override object evaluate() {
            object objectValue = this.parameters[0];
            double valueInError = 0.0;
            if (this.parameters.Length > 1 && this.parameters[1] != null) { //error value is defined
                valueInError = (double)this.parameters[1];
            }
            try {
                return Convert.ToDouble(objectValue, CultureInfo.InvariantCulture);
            } catch (Exception e) {
                if (this.parameters.Length > 1 && this.parameters[1] != null) {
                    return valueInError;
                } else {
                    throw new Exception("Error in converting \"" + objectValue + "\" to double");
                }
            }
        }

    }
}