﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {
    public class converttoint : CustomFunctionBase {

        public converttoint(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object", "int" }) {
        }

        public override object evaluate() {
            object objectValue = this.parameters[0];
            int valueInError = 0;
            if (this.parameters.Length > 1 && this.parameters[1] != null) { //error value is defined
                valueInError = (int)this.parameters[1];
            }
            try {
                return Convert.ToInt64(objectValue, CultureInfo.InvariantCulture);
            } catch (Exception e) {
                if (this.parameters.Length > 1 && this.parameters[1] != null) {
                    return valueInError;
                } else {
                    throw new Exception("Error in converting \"" + objectValue + "\" to integer");
                }
            }
        }

    }
}