﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Globalization;

namespace QPR.QPRSuite.NCalc {
    public class converttostring : CustomFunctionBase {

        public converttostring(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object", "string" }) {
        }

        public override object evaluate() {
            object objectValue = this.parameters[0];
            string valueInError = "";
            if (this.parameters.Length > 1 && this.parameters[1] != null) { //error value is defined
                valueInError = (string)this.parameters[1];
            }
            try {
                return Convert.ToString(objectValue, CultureInfo.InvariantCulture);
            } catch (Exception e) {
                if (this.parameters.Length > 1 && this.parameters[1] != null) {
                    return valueInError;
                } else {
                    throw new Exception("Error in converting \"" + objectValue + "\" to string");
                }
            }
        }

    }
}