﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class datasetcell : CustomFunctionBase {

        public datasetcell(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "String", "Int" }) {
        }

        public override object evaluate() {
            DataSet dataSet = (DataSet)this.parameters[0];
            string columnName = (string)this.parameters[1];
            if (dataSet == null) return null;
            if (string.IsNullOrEmpty(columnName)) throw new Exception("Column name must not be empty in DataSetCell");
            int columnNumber = dataSet.getColumnNumber(columnName);
            if (columnNumber == -1) throw new Exception("Column \"" + columnName + "\" not found.");
            int rowNumber = (int)this.parameters[2];
            if (rowNumber < 1) throw new Exception("Row number is not valid in DataSetCell");
            if (rowNumber >= dataSet.rowsCount()) throw new Exception("Row index \"" + rowNumber + "\" doesn't exist. (number of rows " + dataSet.rowsCount() + ")");
            return dataSet.getCell(columnNumber, rowNumber - 1);
        }

    }
}