﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class datasetcolumntoarray : CustomFunctionBase {

        public datasetcolumntoarray(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "String", }) {
        }

        public override object evaluate() {
            DataSet dataSet = (DataSet)this.parameters[0];
            if (dataSet == null) return null;
            string columnName = (string)this.parameters[1];
            if (string.IsNullOrEmpty(columnName)) throw new Exception("Column name must not be empty in DataSetColumnToArray");
            int columnNumber = dataSet.getColumnNumber(columnName);
            List<object> outputList = new List<object>();
            for (int i = 0; i < dataSet.rowsCount(); i++) {
                outputList.Add(dataSet.getCell(columnNumber, i));
            }
            return outputList.ToArray();
        }

    }
}