﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class datasetrowtoarray : CustomFunctionBase {

        public datasetrowtoarray(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "Int" }) {
        }

        public override object evaluate() {
            DataSet dataSet = (DataSet)this.parameters[0];
            if (dataSet == null) return null;
            int rowNumber = (int)this.parameters[1];
            if (rowNumber < 1) throw new Exception("Row number must be a positive number in DataSetRowToArray");
            List<object> outputList = new List<object>();
            rowNumber = rowNumber - 1;
            for (int i = rowNumber; i < dataSet.columnsCount(); i++) {
                outputList.Add(dataSet.getCell(i, rowNumber));
            }
            return outputList.ToArray();
        }

    }
}