﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class eval : CustomFunctionBase {

        public eval(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "string" }) {
        }

        public override object evaluate() {
            string expression = (string)this.parameters[0];
            if (string.IsNullOrEmpty(expression)) return expression;
            Dictionary<string, object> arguments = new Dictionary<string, object>();
            for (int i = 1; i < this.parameters.Length; i++) {
                arguments["argument" + (i + 1)] = this.parameters[i];
            }
            object result = null;
            try {
                result = this.context.getExpressionEngine().evaluateExpressionAsObject(expression, arguments);
            } catch (Exception e) {
                throw new Exception("Error in function Eval when evaluating expression: " + expression, e);
            }
            return result;
        }
    }
}