﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class evalwithnamedarguments : CustomFunctionBase {

        public evalwithnamedarguments(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "string" }) {
        }

        public override object evaluate() {
            if (this.parameters.Length % 2 == 0) throw new Exception("Function EvalWithNamedArguments must have odd number of parameters");
            string expression = (string)this.parameters[0];
            if (string.IsNullOrEmpty(expression)) return expression;
            Dictionary<string, object> arguments = new Dictionary<string, object>();
            for (int i = 1; i < this.parameters.Length; i = i + 2) {
                object argumentName = this.parameters[i];
                if (!(argumentName is string)) throw new Exception("Argument names must be strings in function EvalWithNamedArguments");
                if (arguments.ContainsKey((string)argumentName)) throw new Exception("There is already added an argument with name \"" + (string)argumentName + "\" in function EvalWithNamedArguments");
                arguments[(string)argumentName] = this.parameters[i + 1];
            }
            object result = null;
            try {
                result = this.context.getExpressionEngine().evaluateExpressionAsObject(expression, arguments);
            } catch (Exception e) {
                throw new Exception("Error in function EvalWithNamedArguments when evaluating expression: " + expression, e);
            }
            return result;
        }
    }
}