﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class except : CustomFunctionBase {

        public except(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "DataSet" }) {
        }

        public override object evaluate() {
            DataSet dataSet1 = (DataSet)this.parameters[0];
            DataSet dataSet2 = (DataSet)this.parameters[1];
            if (dataSet2 == null) return dataSet1;
            if (dataSet1 == null) return null;
            dataSet2 = dataSet2.reorderRows(dataSet1);
            if (!dataSet1.containsSameColumns(dataSet2)) throw new Exception("Datasets don't contain same columns in Except function");
            DataSet newDataSet = new DataSet(dataSet1.getColumns());
            for (int i = 0; i < dataSet1.rowsCount(); i++) {
                DataSetRow row = dataSet1.getRow(i);
                if (!dataSet2.contains(row)) {
                    row.copyRow(newDataSet);
                }
            }
            return newDataSet;
        }

    }
}