﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {

    public class loop : CustomFunctionBase {

        public loop(FunctionArgs args, IContextManager context)
            : base(args, context, 1, new string[] { "object[]" }) {
        }

        public override object evaluate() {
            object[] array = (object[])this.parameters[0];
            if (array == null) return null;
            object formulaResult = null;
            for (int i = 0; i < array.Length; i++) {
                Dictionary<string, object> arguments = new Dictionary<string, object>();
                arguments.Add("index", i);
                arguments.Add("previousresult", formulaResult);
                arguments.Add("value", array[i]);
                for (int j = 2; j < this.parameters.Length; j++) {
                    arguments.Add("argument" + (j - 1), this.parameters[j]);
                }
                formulaResult = context.getExpressionEngine().evaluateExpressionAsObject((string)this.parameters[1], arguments);
            }
            return formulaResult;
        }

    }
}