﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Web;

namespace QPR.QPRSuite.NCalc {

    public class qprembeddedfiledata : CustomFunctionBase {

        private string objectId;
        private string attribute;
        private string options;

        public qprembeddedfiledata(FunctionArgs args, IContextManager context)
            : base(args, context, 3, new string[] { "string", "string", "string" }) {
            objectId = Convert.ToString(args.Parameters[0].Evaluate(), CultureInfo.InvariantCulture);
            attribute = Convert.ToString(args.Parameters[1].Evaluate(), CultureInfo.InvariantCulture);
            options = Convert.ToString(args.Parameters[2].Evaluate(), CultureInfo.InvariantCulture);
        }

        public override object evaluate() {
            if (objectId == null || objectId == "" || attribute == null || attribute == "") {
                return new byte[0];
            }
            BinaryData fileData = null;
            fileData = this.context.getWebServiceClient().getBinaryData(objectId, attribute, options);
            if (fileData == null || fileData.Content == null) {
                return new byte[0];
            } else {
                return fileData.Content;
            }
        }

    }

}
