﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Web;

namespace QPR.QPRSuite.NCalc {

    public class qprgraphdata : CustomFunctionBase {

        private string objectId;
        private string options;

        public qprgraphdata(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "string", "string" }) {
            objectId = Convert.ToString(args.Parameters[0].Evaluate(), CultureInfo.InvariantCulture);
            options = Convert.ToString(args.Parameters[1].Evaluate(), CultureInfo.InvariantCulture);
        }

        public override object evaluate() {
            if (!options.ToLower().Contains("type=")) options = options + (options != "" ? "," : "") + "type=" + context.getMandatoryNotEmptyApplicationSetting("defaultimageformat");
            if (objectId.Contains(",")) objectId = objectId.Substring(0, objectId.IndexOf(","));
            BinaryData imageData = this.context.getWebServiceClient().getGraph(objectId, options);
            if (imageData.Content == null) {
                return new byte[0];
            } else {
                return imageData.Content;
            }
        }

    }
}
