﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class removecolumn : CustomFunctionBase {

        public removecolumn(FunctionArgs args, IContextManager context)
            : base(args, context, 2, new string[] { "DataSet", "String" }) {
        }

        public override object evaluate() {
            DataSet oldDataSet = (DataSet)this.parameters[0];
            if (oldDataSet == null) return null;
            List<string> newColumns = new List<string>(oldDataSet.getColumns());
            string removedColumnName = (string)this.parameters[1];
            if (string.IsNullOrEmpty(removedColumnName)) throw new Exception("Column name is not allowed to be empty in RemoveColumn");
            newColumns.Remove(removedColumnName);
            DataSet newDataSet = new DataSet(newColumns.ToArray());
            for (int i = 0; i < oldDataSet.rowsCount(); i++) {
                object[] oldRowData = oldDataSet.getRow(i).getData();
                object[] newRowData = new object[newColumns.Count];
                int newRowDataCounter = 0;
                for (int j = 0; j < oldDataSet.columnsCount(); j++) {
                    if (newColumns[newRowDataCounter] == oldDataSet.getColumnName(j)) {
                        newRowData[newRowDataCounter] = oldDataSet.getCell(j, i);
                        newRowDataCounter++;
                    }
                }
                newDataSet.addRow(newRowData);
            }
            return newDataSet;
        }

    }
}