﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Xml.Linq;
using System.Xml;
using System.Xml.XPath;
using System.Linq;
using System.Collections.Generic;

namespace QPR.QPRSuite.NCalc {
    public class selectxmlattributes : CustomFunctionBase {

        public selectxmlattributes(FunctionArgs args, IContextManager context)
            : base(args, context, 5, new string[] { "object", "string", "string", "string", "string" }) {
        }

        public override object evaluate() {
            XElement element = null;
            if (this.parameters[0] == null) {
                return null;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xdocument") {
                element = ((XDocument)this.parameters[0]).Root;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xelement") {
                element = (XElement)this.parameters[0];
            } else {
                throw new Exception("Type of first parameter is wrong in \"SelectXmlAttributes\" function");
            }
            if (element == null) throw new Exception("XML document or element was empty in \"SelectXmlAttributes\" function");
            string xPathQuery = (string)this.parameters[1];
            if (string.IsNullOrEmpty(xPathQuery)) throw new Exception("XPath query was empty in \"SelectXmlAttributes\" function");
            string namespacePrefix = (string)this.parameters[2];
            if (string.IsNullOrEmpty(namespacePrefix)) throw new Exception("Namespace prefix query was empty in \"SelectXmlAttributes\" function");
            string namespaceUri = (string)this.parameters[3];
            if (string.IsNullOrEmpty(namespaceUri)) throw new Exception("Namespace URI query was empty in \"SelectXmlAttributes\" function");
            string attributeName = (string)this.parameters[4];
            if (string.IsNullOrEmpty(attributeName)) throw new Exception("Attribute name was empty in \"SelectXmlAttributes\" function");
            XmlNamespaceManager namespaceManager = new XmlNamespaceManager(new NameTable());
            namespaceManager.AddNamespace(namespacePrefix, namespaceUri);
            XElement[] xElements = element.XPathSelectElements(xPathQuery, namespaceManager).ToArray<XElement>().ToArray<XElement>();
            List<string> attributeValues = new List<string>();
            for (int i = 0; i < xElements.Length; i++) {
                XAttribute attribute = xElements[i].Attribute(attributeName);
                string attributeValue;
                if (attribute == null) {
                    attributeValue = "";
                } else {
                    attributeValue = attribute.Value;
                }
                attributeValues.Add(attributeValue);
            }
            return attributeValues.ToArray<string>();
        }

    }
}