﻿using NCalc;
using QPR.QPRSuite.AcceleratorTools;
using System;
using System.Xml.Linq;
using System.Xml;
using System.Xml.XPath;

namespace QPR.QPRSuite.NCalc {
    public class selectxmlelement : CustomFunctionBase {

        public selectxmlelement(FunctionArgs args, IContextManager context)
            : base(args, context, 4, new string[] { "object", "string", "string", "string" }) {
        }

        public override object evaluate() {
            XElement element = null;
            if (this.parameters[0] == null) {
                return null;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xdocument") {
                element = ((XDocument)this.parameters[0]).Root;
            } else if (this.parameters[0].GetType().Name.ToLower() == "xelement") {
                element = (XElement)this.parameters[0];
            } else {
                throw new Exception("Type of first parameter is wrong in \"SelectXmlElement\" function");
            }
            if (element == null) throw new Exception("XML document or element was empty in \"SelectXmlElement\" function");
            string xPathQuery = (string)this.parameters[1];
            if (string.IsNullOrEmpty(xPathQuery)) throw new Exception("XPath query was empty in \"SelectXmlElement\" function");
            string namespacePrefix = (string)this.parameters[2];
            if (string.IsNullOrEmpty(namespacePrefix)) throw new Exception("Namespace prefix query was empty in \"SelectXmlElement\" function");
            string namespaceUri = (string)this.parameters[3];
            if (string.IsNullOrEmpty(namespaceUri)) throw new Exception("Namespace URI query was empty in \"SelectXmlElement\" function");
            XmlNamespaceManager namespaceManager = new XmlNamespaceManager(new NameTable());
            namespaceManager.AddNamespace(namespacePrefix, namespaceUri);
            return element.XPathSelectElement(xPathQuery, namespaceManager);
        }

    }
}