﻿using QPR.QPRSuite.NCalc;
using System;

namespace QPR.QPRSuite.AcceleratorTools {
    public interface IContextManager : IDisposable {
        string getExpressionLanguageVersion();
        string getApplicationVersion();
        IWebServiceClient getWebServiceClient();
        IModellingClient getModellingClient();
        IMetricsClient getMetricsClient();
        ExpressionEngine getExpressionEngine();
        ILogger getLogger();
        //throws an exception if the application setting is not found or if it's empty
        string getMandatoryNotEmptyApplicationSetting(string settingName);
        //throws an exception if the application setting is not found
        string getMandatoryApplicationSetting(string settingName);
        //return null is the application setting is not found
        string getOptionalApplicationSetting(string settingName);
        void setApplicationSetting(string name, string value);
        string removeInvalidFileNameChars(string input);
        string removeInvalidXMLChars(string input);
    }
}
