﻿using QPR.QPRSuite.AcceleratorTools.QPRWebService;
using System;
using System.IO;

namespace QPR.QPRSuite.AcceleratorTools {
    public interface IWebServiceClient : IDisposable {
        string getAttributeAsString(string objectId, string attribute, string options);
        ResultSet queryObjects(string query, string criteria, string sortBy, string attributes, string options);
        string getPortalUrl(string objectId, string view, string options);
        string createObject(string namespaceId, string typename, string name, string parentIds, string[][] attributes, string options);
        void setAttribute(string objectId, string attribute, string value, string options);
        void setAttributes(string objectIds, string[][] attributes, string options);
        BinaryData getGraph(string objectIds, string options);
        Stream getGraphAsStream(string objectIds, string options);
        BinaryData getBinaryData(string objectId, string attribute, string options);
        void deleteObject(string objectId, string options);
        string getWebServiceSessionId();
    }

    public enum WCFSecurityMode { none, message, transport, transportwithmessagecredential, notconfigured };
    public enum QPRAuthenticationMode { password, windows, passedsession };
}
